require "LUBE.lua"
require "split.lua" -- wtf isnt this standard?

players = {}

function love.load()
	client = lube.client()
	client:setHandshake("LoveChat Handshake")
	client:setCallback(onReceive)
	client:connect("24.192.196.87", 11988)
	client:setPing(true,5,"ping")
	
	nameEntered = false
	name = ""
	prevMsgBuffer = {}
	msgBuffer = ""
	avatar = love.graphics.newImage("body.png")
end

function onReceive(data)
 	-- Parse message
	delim = string.find(data,string.char(1))
	cmd   = string.sub(data,1,delim-1)
	msg   = string.sub(data,delim+1,#data)
	args  = split(msg,",")
	
	if cmd == "msg" then
		table.insert(prevMsgBuffer,msg)
	end
	if cmd == "newPlayer" then
		table.insert(players,{name = args[2],
		                      x    = args[3],
							  y    = args[4]})
	end
	if cmd == "updateLoc" then
		local i = tonumber(args[1])
		if players[i] ~= nil then
			players[i].x = args[2]
			players[i].y = args[3]
		end
	end
	
	print("Data recieved: " .. data)
end

function love.update(dt)
	client:update(dt)
	client:doPing(dt)
end

function love.keypressed(key,unicode)
	if not nameEntered then
		if key == "lshift" or key == "rshift" or
		   key == "lctrl" or key == "rctrl" or 
		   key == "capslock" then return end
		   
		if key == "return" then
			if #name > 2 then
				client:send("name"..string.char(1)..name)
				nameEntered = true
			end
			
			return
		end
		
		if key == "backspace" then
			name = string.sub(name,1,#name-1)
			return
		end
		
		if #name >= 16 then return end
		
		if string.byte(key) < string.byte("a") or
		   string.byte(key) > string.byte("z") then
			return
		end
		
		name = name .. key
		return
	end
	
	if key == "return" then
		if #name > 2 then
			client:send("msg"..string.char(1)..msgBuffer)
			msgBuffer = ""
		end
		
		return
	end
	
	if key == "backspace" then
		msgBuffer = string.sub(msgBuffer,1,#msgBuffer-1)
		return
	end
	
	if key == "right" then client:send("move"..string.char(1).."right") return end
	if key == "left" then client:send("move"..string.char(1).."left") return end
	if key == "up" then client:send("move"..string.char(1).."up") return end
	if key == "down" then client:send("move"..string.char(1).."down") return end
	
	if #msgBuffer > 50 then return end
	
	if not love.keyboard.isDown("lshift") and not love.keyboard.isDown("rshift") then
		msgBuffer = msgBuffer .. key
	else
		local char = ""
		
		if key == "lshift" or key == "rshift" then
			return
		end
		
		if string.byte(key) >= string.byte("a") or
		   string.byte(key) <= string.byte("z") then
			char = string.char(string.byte(key)-32)
		end
		
		if key == "1" then char = "!" end
		if key == "2" then char = "@" end
		if key == "3" then char = "#" end
		if key == "4" then char = "$" end
		if key == "5" then char = "%" end
		if key == "6" then char = "^" end
		if key == "7" then char = "&" end
		if key == "8" then char = "*" end
		if key == "9" then char = "(" end
		if key == "0" then char = ")" end
		if key == "'" then char = "\"" end
		if key == "`" then char = "~" end
		if key == "-" then char = "_" end
		if key == " " then char = " " end
		if key == "/" then char = "?" end
		if key == ";" then char = ":" end
				
		msgBuffer = msgBuffer .. char
	end
end

function love.draw()
	-- Draw user name prompt
	if not nameEntered then
		love.graphics.print("Enter your name: " .. name,20,20)
		return
	end
	
	-- Draw enter message prompt
	love.graphics.print("message: "..msgBuffer,40,20)
	
	-- Redraw messages when there's a new one
	for i=#prevMsgBuffer, 1, -1 do
		love.graphics.print(prevMsgBuffer[i],40,14*(#prevMsgBuffer-i)+50)
	end
	
	for i=1, #players do
		love.graphics.draw(avatar, players[i].x, players[i].y)
	end
end

function love.quit()
	client:disconnect()
end